/*********************************************************************************
Prctica 1 de Procesadores del Lenguaje I
Nombre: Oscar Martnez Valpuesta
Objetivo: Implementar un programa lex que reconozca la linea de comandos y
	muestre diferentes mensajes ante diferentes opciones.
Version: version para flex
**********************************************************************************/

%{
char *entrada;		/* string de entrada --> toda la linea decomandos */ 
int modo;	/* 0 FALSE, 1 TRUE */
char *myinputptr;		/* posicion en la cadena de entrada */
char *myinputlim;		/* tamao de la entrada */
#undef YY_INPUT
#define YY_INPUT(b,r,ms) (r = my_yyinput(b,ms)) 
%}

ayuda -help|-h|-? 
verbose	-v|-verbose
fichero	-f|-file
%s FNAME

/* parte de patrn-accin */
%%
<FNAME>[ ][^ ]+ {printf("%s%s\n", "Se esta usando el fichero ", yytext);
		BEGIN 0;}
<FNAME>[ ]+ {printf("%s\n","ERROR, nombre se fichero no introducido.");
		BEGIN 0;}
{ayuda} printf("%s\n", "Modo de uso: comando [-help | -h | -?] [-verbose | -v] [(-file | -f) filename]");
{verbose} {if (modo == 1) {
		printf("%s\n","verbose mode on");
		modo = 0;}
	  else {
		printf("%s\n", "verbose mode off");
		modo = 1;}
	  } 
{fichero} BEGIN FNAME;
[ ] ;
%%
/* funcin que lee caracteres de la entrada y devuelve el n leido */
int my_yyinput(char *buf, int max_size){
int n;

  if (max_size > (myinputlim - myinputptr))
    n = (myinputlim - myinputptr);
  else
    n = max_size;
  if (n > 0) {
    memcpy(buf, myinputptr,n);
    myinputptr += n;
  }
  return n;
}

main(int argc, char *argv[]) {
int i;
int j;
int posicion;

  posicion = 0;
  modo = 1;
  entrada= (char *)malloc(50*sizeof(char));
  for (i = 1; i < argc; i++) {
    /* pasamos a entrada todos los argumentos de la linea de comandos */
    for (j = 0; j < strlen(argv[i]); j++) 
      entrada[posicion++] = argv[i][j];
    entrada[posicion++] = ' '; 

  }
  entrada[posicion] = '\0';
  myinputptr = entrada;
  myinputlim = myinputptr + strlen(entrada);
  yylex();      
  free(entrada);
}

yywrap() {
   return 1;
}
