/********************************************************************************
   Modulo de definicion de la tabla de simbolos y rutinas necesarias para su
   manipulacion.
********************************************************************************/
#include "tok.h"
#include <stdlib.h>
struct entry *symtab;      /* symbol table */

/********************************************************************************/ 
/*Procedimiento que muestra el error s en pantalla y termina la ejecucion */ 
void Mi_Error( char *s ){ 

  printf("%s\n", s);
  exit (0);		      
}/* error */ 

/*******************************************************************************/
/*Inicializacion de la tabla de simbolos */
void init(){

  symtab = (struct entry *)malloc(sizeof(struct entry));
  if (symtab == NULL) 
    Mi_Error("ERROR, no se ha podido dar memoria a la tabla de simbolos");
  symtab->next = NULL;
} /* init */


/********************************************************************************/
/*Aade una nueva estructura a la lista y devuelve el top de la pila */
struct entry *create( char *name ){
struct entry *nueva;

  nueva = (struct entry *)malloc(sizeof(struct entry));
  if (nueva == NULL)
    Mi_Error("ERROR, no hay memoria suficiente para una entrada en la tabla de simbolos");
  
  nueva->name = (char *)malloc(strlen(name)*sizeof(char));
  nueva->name = name;
  nueva->next = symtab;
  return nueva;
} /* create */

/********************************************************************************/  
/*Busca una entrada en la lista con el nombre name y devuelve un puntero
a esa entrada. Si no se encuentra se devuelve un puntero nulo */
struct entry *find( char *name){
struct entry *aux;

  aux = symtab;
  while (aux->next != NULL) 
    if (strcmp(name, aux->name))
	return aux;

  return NULL;               /* no se ha encontrado */
}/* find */

/*Funcion que mira si un determinado nombre esta en la tabla. Si esta devuelve
   un puntero a ese registro. si no esta lo inserta y devuelve un puntero al 
   nuevo registro */
struct entry *lookUp( char *s ){
struct entry *aux;

  aux = find(s);  
  if (aux == NULL)
    return (create(s));
  else
    return (aux);

} /* lookUp */
