/*
  PRACTICA 7 - Oscar Martinez Valpuesta
  Expresiones con sumas,restas, multiplicaciones, etc.
  Acepta funciones de la libreria matemtica y variables. 
 */

%{
#define YYDEBUG 1 
#include <math.h>  
#include "symbol.h"

struct entry *nodo;
%}

%union {
  double valorReal;
  double (*funcion)();
  struct entry *ptr;
}

%type <valorReal> E

%token<valorReal>NUM
%token<funcion>FUNCTION
%token<ptr>VARIABLE

%right '='
%left '+''-'
%left '*''/'
%left UNARIO
%left '^'
%%
S : S '\n'E	{printf("%f\n",$3);}
  | E		{printf("%f\n",$1);}
  ;
E : E '+' E 	{$$=$1+$3;}
  | E '-' E	{$$=$1-$3;}
  | E '*' E	{$$=$1*$3;}
  | E '/' E	{$$=$1/$3;}
  | E '^' E	{$$=pow($1,$3);}
  | '(' E ')'	{$$=$2;}
  | '-' E %prec UNARIO {$$=-$2;} 
  | NUM
  | FUNCTION '(' E ')'	{$$=(*$1)($3);}
  | VARIABLE '=' E	{$1->valor=$3;
			$$=$3;} 
  |VARIABLE		{$$=$1->valor;}
  ;
%%

main() {
extern int yydebug;

  yydebug = 0;

  yyparse();
} /* main */
