/* Declaraciones */

%{
#include "y.tab.h"
#include "symbol.h"
#include <math.h>

#define NUM_FUNCIONES 5

char *funciones[NUM_FUNCIONES] = {"sin","cos","tan","log","sqrt"};
double (*ptr_funciones[NUM_FUNCIONES])() = {sin,cos,tan,log,sqrt};

int i;
%}
digito [0-9]
numero [0-9]+
numero_real {numero}(.{numero})?
letra [a-zA-Z]
identificador {letra}({letra}|{digito}|_){0,31}
%%

[ \t]+   ;
{numero_real}	{yylval.valorReal = atof(yytext);
 		return NUM;
		}
sin|cos|tan|log|sqrt	{for (i = 0; i < NUM_FUNCIONES; i++)
			  if (strcmp (yytext, funciones[i])) {
			    yylval.funcion = ptr_funciones[i];
			    return FUNCTION;
			  }
			}
{identificador}	{yylval.ptr = lookUp(yytext);
		return VARIABLE;
		}
[-+*/()\^\=\n]   return *yytext;
%%

int yywrap() {

  return 1;
}

void yyerror(char *s) {

  printf("%s\n", s);
  return;
}
