/* PROCESADORES DEL LENGUAJE I - Oscar Martinez Valpuesta - 4 Ingenieria Informatica
PRACTICA 8: Formateador de ficheros */

%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define YYDEBUG 1
#include "symbol.h"
extern FILE *yyin;
FILE *output;
int nivel = 0;
int expr = 1;

%}

%union { 
	struct entry *ptr;
	int value;
};

%token ID
%token CONST 
%token IF 
%token ELSE
%token WHILE
%token BREAK
%token CONTINUE
%token RETURN 
%token GE
%token LE
%token EQ
%token NE
%token PE
%token ME
%token TE
%token DE
%token RE
%token PP
%token MM
%token INT

%left ';'
%right '=' PE ME TE DE RE
%left '|'
%left '^'
%left '&'
%left EQ NE
%left '<' LE '>' GE
%left '+' '-'
%left '*' '/' '%'
%left PP MM UNARIO
%left '(' ')'

%%
program	: definitionL
        ;
definitionL	:
		| definitionL definition
		;
definition	: dataDefinition
		| functionDefinition
	        ;
dataDefinition	: impINT declarator declaratorL impPYC	
	        ;
declaratorL	:
		| declaratorL impC declarator
		;
declarator : impID
           ;
functionDefinition	: functionHeader functionBody
			| impINT functionHeader functionBody
			;
functionHeader	: declarator parameterList
		;
parameterList	: impAP identifierList {expr = 1;} impCP parameterDeclarationL
		| impAP impCP parameterDeclarationL
		;
parameterDeclarationL	:
			| parameterDeclarationL parameterDeclaration
			;
identifierList	: impID IDL
		;
IDL	:
	| IDL impC impID
	;
parameterDeclaration	: impINT declarator declaratorL impPYC 
			;
functionBody	: impALL dataDefinitionL stamentL impCLL 
		;
dataDefinitionL	:
		| dataDefinitionL dataDefinition
		;
stamentL	:
		| stamentL stament
		;
stament	: impPYC 
	| expression impPYC 
	| impALL dataDefinitionL stamentL impCLL 
	| impIF impAP expression impCP stament
	| impIF impAP expression impCP stament impELSE stament
	| impWHILE impAP expression impCP stament
	| BREAK {imp("break");} impPYC
	| CONTINUE {imp("continue");} impPYC
	| RETURN {imp("return");} impPYC	
	| RETURN {imp("return ");} expression impPYC
	;
expression	: binary binaryL
		;
binaryL	:
	| binaryL impC binary
	;
binary	: impID '=' {imp(" = ");} binary
	| impID PE {imp(" += ");} binary
	| impID ME {imp(" -= ");} binary
	| impID TE {imp(" *= ");} binary
	| impID DE {imp(" /= ");} binary
	| impID RE {imp(" %= ");} binary
	| binary '+' {imp(" + ");} binary
	| binary '-' {imp(" - ");} binary
	| binary '*' {imp(" * ");} binary
	| binary '/' {imp(" / ");} binary
	| binary '%' {imp(" % ");} binary
	| binary '&' {imp(" & ");} binary
	| binary '|' {imp(" | ");} binary
	| binary '^' {imp(" ^ ");} binary
	| binary '<' {imp(" < ");} binary
	| binary '>' {imp(" > ");} binary
	| binary GE {imp(" >= ");} binary
	| binary LE {imp(" <= ");} binary
	| binary EQ {imp(" == ");} binary
	| binary NE {imp(" != ");} binary
	| unary
	;
unary	: PP {imp("++");} impID
	| MM {imp("--");} impID
	| primary
	;
primary	: impID
	| CONST	{fprintf(output,"%d", $1.value);}
	| impAP expression {expr = 0;} impCP
	| impID impAP argumentList {expr = 0;} impCP
	| impID impAP impCP
	;
argumentList	: binary binaryL
		;
impINT	: INT	{imp("int ");}
	;
impC	: ','	{imp(", ");}
	;
impPYC	: ';'	{imp(";\n");
		tab(nivel);}
	;
impID	: ID	{imp($1.ptr->name);}
	;
impAP	: '('	{imp("(");}
	;
impCP	: ')'	{if (expr == 1) {
		  imp(")\n");
		  tab(nivel);
		}
		else
		  imp(")");}
	;
impALL	: '{'	{imp("{\n");
		nivel++;
		tab(nivel);}
	;
impCLL	: '}'	{nivel--;
		imp("\r");
		tab(nivel);
		imp("}\n");
		tab(nivel);}
	;
impIF	: IF	{imp("if ");}
	;
impELSE	: ELSE	{imp("else\n");
		tab(nivel);}
	;
impWHILE	: WHILE	{imp("while ");}
		;
%%

/* Funcion que imprime tantos tabuladores como indique t */
void tab(int t) {
int i;

  for (i=0;i < t;i++) fprintf(output,"   ");
}

void imp(char *s) {

  fprintf(output,"%s", s);
}

/* Funcin principal */
main( int argc, char ** argv ){
FILE *file;
extern yydebug;


  yydebug = 0;
  /* comprobacion de parametros y apertura del fichero */
  if (argc > 1){
    file = fopen(argv[1], "r");
    if ( !file ){
      fprintf(stderr, "no se puede abrir %s\n", argv[1] );
      exit(1);
    }
  } /* if */
  else {
    printf("Forma de uso: a.out fichero.c\n");
    exit (1);
  }

   yyin = file;
  /* creamos el fichero de salida */
  output = fopen("salida.bak","w+");
  if (!output) {
    fprintf(stderr, "\nNo se puede crear el fichero de salida\n");
    exit(1);
  }

  /* Creamos la tabla de palabras reservadas */
   CrearRWtable(); 

  /* Creamos la tabla de simbolos */

  init();
  
  yyparse();
  fclose(output);
  fclose(file);
}
