/* PROCESADORES DEL LENGUAJE I - Oscar Martinez Valpuesta - 4 Ing. Informtica
PRACTICA 9: Recuperacion de errores sintacticos mediante la inclusion de producciones de error
*/

%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define YYDEBUG 1
#include "symbol.h"
extern FILE *yyin;
FILE *output;
%}

%union { 
	struct entry *ptr;
	int value;
};

%token ID
%token CONST 
%token IF 
%token ELSE
%token WHILE
%token BREAK
%token CONTINUE
%token RETURN 
%token GE
%token LE
%token EQ
%token NE
%token PE
%token ME
%token TE
%token DE
%token RE
%token PP
%token MM
%token INT

%left ';'
%right '=' PE ME TE DE RE
%left '|'
%left '^'
%left '&'
%left EQ NE
%left '<' LE '>' GE
%left '+' '-'
%left '*' '/' '%'
%left PP MM UNARIO
%left '(' ')'

%%
program	: definitionL
        ;
definitionL	: definition
		| definitionL definition	{yyerrok;}
		| error
		| definitionL error
		;
definition	: dataDefinition
		| functionDefinition
	        ;
dataDefinition	: INT declaratorL PYC
	        ;
declaratorL	: declarator
		| declaratorL ',' declarator	/* {yyerrok;} */
		| error
		| declaratorL error
		| declaratorL error declarator	{yyerrok;}
		| declaratorL ',' error
		;
declarator : ID
           ;
functionDefinition	: functionHeader functionBody
			| INT functionHeader functionBody
			;
functionHeader	: declarator parameterList
		;
parameterList	: '(' identifierList CP parameterDeclarationL
		| '(' identifierList CP
		| '(' CP parameterDeclarationL
		| '(' CP
		;
parameterDeclarationL	: parameterDeclaration
			| parameterDeclarationL parameterDeclaration	{yyerrok;}
			| error
			| parameterDeclarationL error
			;
identifierList	: IDL
		;
IDL	: ID
	| IDL ',' ID	{yyerrok;}
	| error
	| IDL error
	| IDL error ID	{yyerrok;}
	| IDL ',' error
	;
parameterDeclaration	: INT declaratorL PYC
			;
functionBody	: '{' dataDefinitionL stamentL CLL
		| '{' dataDefinitionL CLL
		| '{' stamentL CLL
		| '{' CLL
		;
dataDefinitionL	: dataDefinition
		| dataDefinitionL dataDefinition	{yyerrok;}
		/* | error
		| dataDefinitionL error */
		;
stamentL	: stament
		| stamentL stament	{yyerrok;}
		/* | error
		| stamentL error */
		;
stament	: PYC 
	| expression PYC
	| '{' dataDefinitionL stamentL CLL
	| '{' dataDefinitionL CLL
	| '{' stamentL CLL
	| '{' CLL
	| IF '(' expression CP stament
	| IF '(' expression CP stament ELSE stament
	| WHILE '(' expression CP stament
	| BREAK PYC
	| CONTINUE PYC
	| RETURN PYC
	| RETURN expression PYC
	;
expression	: binaryL
		;
binaryL	: binary
	| binaryL ',' binary	{yyerrok;}
	| error
	| binaryL error
	| binaryL error binary	{yyerrok;}
	| binaryL ',' error
	;
binary	: ID '=' binary
	| ID PE binary
	| ID ME binary
	| ID TE binary
	| ID DE binary
	| ID RE binary
	| binary '+' binary
	| binary '-' binary
	| binary '*' binary
	| binary '/' binary
	| binary '%' binary
	| binary '&' binary
	| binary '|' binary
	| binary '^' binary
	| binary '<' binary
	| binary '>' binary
	| binary GE binary
	| binary LE binary
	| binary EQ binary
	| binary NE binary
	| unary
	;
unary	: PP ID
	| MM ID
	| primary
	;
primary	: ID
	| CONST
	| '(' expression CP
	| ID '(' argumentList CP
	| ID '(' CP
	;
argumentList	: binary
		| argumentList ',' binary	{yyerrok;}
		| error
		| argumentList error
		| argumentList error binary	{yyerrok;}
		| argumentList ',' error
		;
PYC 	: ';'	{yyerrok;} 
	;
CP	: ')'	{yyerrok;}
	;
CLL	: '}'	{yyerrok;}
	;
%%

/*******************************************************************************************/
/* Funcin principal */
main( int argc, char ** argv ){
FILE *file;
extern yydebug;


  yydebug = 0;
  /* comprobacion de parametros y apertura del fichero */
  if (argc > 1){
    file = fopen(argv[1], "r");
    if ( !file ){
      fprintf(stderr, "no se puede abrir %s\n", argv[1] );
      exit(1);
    }
  } /* if */
  else {
    printf("Forma de uso: a.out fichero.c\n");
    exit (1);
  }

   yyin = file;
  /* creamos el fichero de salida */
  output = fopen("salida.err","w+");
  if (!output) {
    fprintf(stderr, "\nNo se puede crear el fichero de salida\n");
    exit(1);
  }

  /* Creamos la tabla de palabras reservadas */
   CrearRWtable(); 

  /* Creamos la tabla de simbolos */

  init();
  
  yyparse();
  fclose(output);
  fclose(file);
}
