/***********************************************************************************
  Oscar Martinez Valpuesta
  Practica 2 de Procesadores del Lenguaje I
  Objetivo: Implementar un analizador lexico en lex de un subconjunto del
	lenguaje C.
***********************************************************************************/

%{
#include "symbol.c"

const MAXINT = 32767;
const N = 7;	/* n de palabras reservadas */
extern FILE *output;
int yylineno = 1;
%}
digito [0-9]
letra [a-zA-Z]
identificador {letra}({letra}|{digito}|_){0,31}
%x COMENTARIO

%% 
{identificador}	{int reservada = binary(0,N-1);
		if (reservada != 0)
		   return reservada;		/* palabra reservada */
		 else {
		   yylval.ptr = lookUp(yytext);
	                    return ID;
		 }}
{digito}+	{yylval.value = atoi(yytext);
		 if (yylval.value > MAXINT)
                   yylval.value = MAXINT; 
                 return CONST; }
">="		return GE;
"<="		return ME;
"=="		return EQ;
"!="		return NE;
"+="		return PE;
"-="		return ME;
"*="		return TE;
"/="		return DE;
"%="		return RE;
"++"		return PP;
"--"		return MM;
[ ]+|[\t]+	;	/* evitamos espacios en blanco y tabuladores */
[\n]		yylineno++;
"/*"		BEGIN(COMENTARIO);
<COMENTARIO>[\n]	yylineno++;
<COMENTARIO>[^*\n]*     ;  /* pasamos por alto cualquier cosa que no sea '*' */
<COMENTARIO>"*"+[^*/\n]* ;  /* eliminamos todos los '*' no seguidos de '/' */
<COMENTARIO>"*"+"/"      BEGIN(INITIAL);
.	return yytext[0];
%%


yywrap() {

/*  if (YYSTATE == COMENTARIO)
    printf ("ERROR, no se ha cerrado el comentario.\n");
*/  return 1;
}

void yyerror(char *s) {

  fprintf(output,"ERROR en la linea %d, smbolo \"%s\"\t %s\n", yylineno, yytext, s);
  return;
}

